#include<cstdio>
#include<vector>
#include<cassert>
#include<algorithm>
using namespace std;

#define debug if(0)


typedef long long LL;
const LL N5 = 50015;
LL card[N5];
LL perm[N5];
LL inv[N5];
LL n;
bool color[N5];

LL card_cycle[N5];
LL card_pos_in_cycle[N5];

typedef vector<pair<LL,LL> >cykl; //pozycja, po ilu ruchach

vector<cykl>cykle;

void create_cycle(LL v){
	cykl res;
	LL act = 0;
	while(1){
		if(!color[v]) break;
		color[v] = false;

		LL CARD = card[v];
		card_pos_in_cycle[CARD] = act;
		card_cycle[CARD] = (LL)cykle.size();

		res.push_back(pair<LL,LL> (v, act++));
		//printf("v %lld act %lld\n",v,act);
		v = inv[v];
	}
	debug {
		for(LL i=0; i<res.size(); i++) printf("(%lld, %lld) ", res[i].first, res[i].second);
		printf("\n");
	}
	sort(res.begin(), res.end());
	cykle.push_back(res);
}

struct kiedy{
	LL fst;
	LL c;
	kiedy(LL _f=-1, LL _c=-1):fst(_f),c(_c){}
};

kiedy kiedyf(LL karta, LL pos){
	kiedy res;

	cykl &CYKL = cykle[card_cycle[karta]];

	LL p = lower_bound(CYKL.begin(), CYKL.end(), pair<LL,LL>(pos, 0)) - CYKL.begin();
	if(p==(LL)CYKL.size()  || CYKL[p].first!=pos) {
		return kiedy(-1,-1);
	}

	LL fst = CYKL[p].second - card_pos_in_cycle[karta];
	if(fst<0) fst+=CYKL.size();
	return kiedy(fst, CYKL.size());
}

LL PROP[5];

LL A[5],B[5]; // x=A[i] mod B[i]

/** CHINCZYK **/
LL GCD(LL a, LL b){
	LL tmp;
	while(b!=0){
		tmp = b;
		b = a % b;
		a = tmp;
	}
	return a;
}

LL eGCD(LL a, LL b, LL &x, LL &y){
	if(b==0){
		x = 1;
		y = 0;
		return a;
	}
	LL d = eGCD(b,a%b,y,x);
	y = a-x*(a/b)-y;
	x = b-x;
	return d;
}

LL inverse(LL a, LL p){LL x,y; eGCD(a%p+p, p, x, y); return x%p; }

bool crt_error;

LL CRT(LL a, LL m, LL b, LL n){
	b = (b+n-(a%n))%n;
	LL d = GCD(m,n);
	if(b%d!=0){
		crt_error = true;
		return 0;
	}
	LL old_m = m;
	m/=d; b/=d; n/=d;
	return ((b*inverse(m,n))%n)*old_m+a;
}

LL NWW(LL a, LL b){
	LL res = a, d = GCD(a,b);
	res/=d;
	res*=b;
	return res;
}

LL chinczyk(){
	crt_error = false;

	LL x;
	for(LL i=1; i<5; i++){
		x = CRT(A[0], B[0], A[i], B[i]);
		if(crt_error) return -1;
		A[0] = x;
		B[0] = NWW(B[0],B[i]);
	}
	if(x==0) x+=B[0];

	return x;
}
/** CHINCZYK **/

void solve(){
	LL act = 0;
	for(LL i=0; i<n; i++){
		perm[5*i+0] = act++;
		perm[5*i+1] = act++;
	}
	for(LL i=0; i<n; i++){
		perm[5*i+2] = act++;
		perm[5*i+3] = act++;
	}
	for(LL i=0; i<n; i++){
		perm[5*i+4] = act++;
	}
	for(LL i=0; i<5*n; i++) inv[perm[i]] = i;

	debug {for(LL i=0; i<5*n; i++) printf("%lld ",perm[i]); printf("\n"); }

	for(LL i=0; i<5*n; i++) color[i]=true;

	for(LL i=0; i<5*n; i++){
		if(color[i]) {
			create_cycle(i);
		}
	}

	LL BEST = -1;
	LL player;
	kiedy KIEDY;
	for(LL i=0; i<n; i++){
		PROP[0] = 5*i+0;
		PROP[1] = 5*i+1;
		PROP[2] = 5*i+2;
		PROP[3] = 5*i+3;
		PROP[4] = 5*i+4;
		do{
			bool ok = true;
			for(LL k=0; k<5; k++){
				KIEDY = kiedyf(k+1, PROP[k]);
				if(KIEDY.fst==-1){ok = false; break;}

				A[k] = KIEDY.fst;
				B[k] = KIEDY.c;
			}

			if(ok){
				debug {
					printf("\nPROP:\n");
					for(LL k=0; k<5; k++){
						printf("karta %lld na %lld : %lld %lld\n",k+1, PROP[k], A[k], B[k]);
					}
				}

				LL tmp = chinczyk();
				if(tmp>=0){
					debug printf("PLAYER %lld : %lld\n", i+1, tmp);
					if(BEST==-1 || tmp<BEST){
						player = i+1;
						BEST = tmp;
					}
				}
			}
		}while (next_permutation(PROP, PROP+5));
	}

	if(BEST==-1){
		printf("Neverending game.\n");
	} else {
		printf("Player %lld wins game number %lld.\n",player,BEST);
	}
	cykle.clear();
}

main(){
	while(1){
		scanf("%lld",&n);
		if(n==0) break;
		for(LL i=0; i<5*n; i++) {
			scanf("%lld",&card[i]);
		}
		solve();
	}
	return 0;
}
